local mod = ...
local M = {}
M.pin = 4
M.addrTb = {}
M.result = {}
M.dat = ""
local vbat = 0
local step = 1
local countDS = 1
local v, t, hum
local disptmr
disptmr = tmr.create()

M.writeDS = function(tb, addrNo)
	ow.reset(M.pin)
	ow.select(M.pin,  M.addrTb[addrNo])
	for _, v in pairs(tb) do
		ow.write(M.pin, v, 1)
	end
	if tb[1] == 0xBE then M.dat = ow.read_bytes(M.pin, 9) end
	ow.reset(M.pin)
end

M.ncom = {
    {0x44}, -- starttemp
    {0xb4}, --startVolt
    {0xb8, 0x00}, -- recallMem
    {0xBE, 0x00}, -- readPage
	{0x4e, 0x00, 0x00}, -- setVAD,
    {0x4e, 0x00, 0x08}, -- setVVD
    {0x48, 0x00} -- copySP
}
M.psteps = {6,1,2,3,4,'calc1',5,2,3,4,'calc2'}

M.search = function()
    ow.setup(M.pin)
    ow.reset_search(M.pin)
    local adr
    repeat
        adr = ow.search(M.pin)
        if(adr ~= nil) then
            table.insert(M.addrTb, adr)
        end
    until (adr == nil)
    ow.reset_search(M.pin)
    print('Units No:', #M.addrTb)
    --[[
    for _, v in pairs(M.addrTb) do
        local as = ""
        for ii = 1, #v do as = as..string.format("%02X", (string.byte(v, ii))) end
    	print(as)
    end
    --]]
    M.addr = M.addrTb[1]
    disptmr:start()
end

M.calc = function(arg)
	if M.dat:byte(9) == ow.crc8(string.sub(M.dat,1,8)) then	
		v = ((M.dat:byte(5) * 256) + M.dat:byte(4)) / 100
		if arg == 'calc1' then
			vbat = v
			return
		else
			local mb = M.dat:byte(3)
    		local raw = (mb > 127) and (-256 + mb) or mb
			t = (raw + (bit.rshift(M.dat:byte(2), 3)) * 0.03125)
			hum = (((v/vbat) - 0.1515)/0.00636)/(1.0546 - 0.00216 * t)
			M.result['temp0'..countDS] = t
			M.result['hum0'..countDS] = hum
			M.result['ahum0'..countDS] = ((6.112*(math.pow(2.718281828,(17.67*t)/(t+243.5)))*hum*2.1674)/(273.15+t))
		end
	else
		print('Alarm CRC!')
		if not dat then dat ={} end
		dat.modulerror = countDS 
	end
end

disptmr:register(30, tmr.ALARM_AUTO, function(t)
    if type(M.psteps[step]) == 'number' then
    	M.writeDS(M.ncom[M.psteps[step]], countDS, read)
    else
    	M.calc(M.psteps[step])
    end
    step = step + 1
    if step == 13 then
        if countDS  ~= #M.addrTb then
            countDS = countDS + 1
            M.addr = M.addrTb[countDS]
            step = 1
        else 
            t:stop()
            t:unregister()
            t = nil
            disptmr = nil
            table.foreach(M.result,print)
            package.loaded[mod] = nil
            if M.call then M.call() end
        end
    end
end)

M.askds = function(tbl, call, pin)
	if pin then M.pin = pin end
	if tbl then M.result = tbl end
	if call then M.call = call end
	M.search()
end
return M